%define anolis_release 1

%bcond_without check

%global crate mdevctl

Name:           mdevctl
Version:        1.2.0
Release:        %{anolis_release}%{?dist}
Summary:        A mediated device management utility for Linux

License:        LGPLv2
URL:            https://crates.io/crates/mdevctl
Source0:        https://github.com/mdevctl/mdevctl/archive/refs/tags/v%{version}.tar.gz
Source1:        https://github.com/mdevctl/mdevctl/releases/download/v%{version}/mdevctl-%{version}-vendor.tar.gz 

BuildRequires: make systemd rust-packaging python3-docutils
Requires(post,postun): %{_sbindir}/udevadm

%description
mdevctl is a utility for managing and persisting devices in the
mediated device device framework of the Linux kernel.  Mediated
devices are sub-devices of a parent device (ex. a vGPU) which
can be dynamically created and potentially used by drivers like
vfio-mdev for assignment to virtual machines.

%package doc
Summary:        Doc files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description doc
Doc files for %{name}

%prep
%autosetup -p1
%setup -q -D -T -a 1
mkdir -p .cargo
cat >.cargo/config <<EOF
[source.crates-io]
replace-with = "vendored-sources"
[source.vendored-sources]
directory = "vendor"
EOF

%build
%cargo_build

%install
%make_install

%if %{with check}
%check
%cargo_test
%endif

%files
%license COPYING
%{_sbindir}/mdevctl
%{_sbindir}/lsmdev
%{_udevrulesdir}/60-mdevctl.rules
%dir %{_sysconfdir}/mdevctl.d
%dir %{_sysconfdir}/mdevctl.d/scripts.d/callouts
%dir %{_sysconfdir}/mdevctl.d/scripts.d/notifiers
%{_mandir}/man8/mdevctl.8*
%{_mandir}/man8/lsmdev.8*
%{_datadir}/bash-completion/completions/mdevctl
%{_datadir}/bash-completion/completions/lsmdev

%files doc
%doc README.md

%changelog
* Sat Mar 18 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1.2.0-1
- init from upstream
